SystemOrganization addCategory: #'Coral-Core'!

!UnixProcess methodsFor: '*Coral-Core' stamp: 'DamienPollet 8/13/2011 03:14'!
newLineInConsole
	
	^String lf! !

!Class methodsFor: '*Coral-Core' stamp: 'DamienPollet 12/15/2011 15:13'!
< aSubclassSymbol

	^ self subclass: aSubclassSymbol! !

!Class methodsFor: '*Coral-Core' stamp: 'DamienPollet 8/13/2011 03:11'!
iv: aStringOfaSingleOrMultipleIV

	^ self addInstVarNamed: aStringOfaSingleOrMultipleIV! !

!Class methodsFor: '*Coral-Core' stamp: 'DamienPollet 8/13/2011 03:11'!
shared: aStringOfaSingleOrMultipleClassVar

	^ self addClassVarNamed: aStringOfaSingleOrMultipleClassVar! !

!FileStream methodsFor: '*Coral-Core' stamp: 'DamienPollet 8/20/2011 15:06'!
newline
	self flag: 'TODO: should determine platform convention'.
	^ self nextPut: Character lf! !

!WindowsProcess methodsFor: '*Coral-Core' stamp: 'DamienPollet 8/13/2011 03:15'!
newLineInConsole
	
	^String cr, String lf! !

PPCompositeParser subclass: #PPCoralGrammar
	instanceVariableNames: 'block method program methodHeader methodBody shebang smalltalk startExpression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Core'!

!PPCoralGrammar class methodsFor: 'accessing' stamp: 'lr 12/7/2009 13:53'!
ignoredNames
	^ super ignoredNames , #(smalltalk)! !

!PPCoralGrammar class methodsFor: 'accessing' stamp: 'DamienPollet 8/12/2011 19:08'!
parseExpression: aString
	^ self new parseExpression: aString! !

!PPCoralGrammar class methodsFor: 'accessing' stamp: 'DamienPollet 8/12/2011 19:08'!
parseExpression: aString onError: aBlock
	^ self new parseExpression: aString onError: aBlock! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'lr 11/28/2009 18:25'!
block
	^ self smalltalk block! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'sd 11/8/2010 10:07'!
method

	^ methodHeader , methodBody! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'DamienPollet 8/12/2011 18:25'!
methodBody
	^ $[ asParser token trim ,
		self smalltalk pragmas ,
		self smalltalk temporaries ,
		self smalltalk pragmas ,
		self smalltalk statements ,
		$] asParser token trim! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'DamienPollet 8/12/2011 18:25'!
methodHeader

	^ self smalltalk identifierToken ,
		'class' asParser token trim optional ,
		'>>' asParser token trim ,
		self smalltalk methodDeclaration! !

!PPCoralGrammar methodsFor: 'parsing' stamp: 'DamienPollet 8/12/2011 18:38'!
parseExpression: aString
	^ self parseExpression: aString onError: [ :msg :pos | self error: msg ]! !

!PPCoralGrammar methodsFor: 'parsing' stamp: 'DamienPollet 8/12/2011 18:41'!
parseExpression: aString onError: aBlock
	^ startExpression parse: aString onError: aBlock! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'DamienPollet 8/12/2011 18:25'!
program
	^ shebang optional , (block / method) star! !

!PPCoralGrammar methodsFor: 'productions' stamp: 'DamienPollet 8/12/2011 18:24'!
shebang
	^ '#!!' asParser , (#newline asParser negate) star! !

!PPCoralGrammar methodsFor: 'composition' stamp: 'lr 11/28/2009 18:48'!
smalltalk
	^ smalltalk ifNil: [ smalltalk := PPSmalltalkGrammar new ]! !

!PPCoralGrammar methodsFor: 'accessing' stamp: 'lr 11/28/2009 18:16'!
start
	^ program end! !

!PPCoralGrammar methodsFor: 'accessing' stamp: 'DamienPollet 8/12/2011 18:26'!
startExpression
	^ smalltalk startExpression! !

PPCoralGrammar subclass: #PPCoralParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Core'!

!PPCoralParser class methodsFor: 'as yet unclassified' stamp: 'TestRunner 12/7/2009 16:09'!
todo

	"use last version of OSProcess"
	"merge PetitCoral and Coral"
	"Create a configuration to load everything in one click"
	
	"DONE After"
	"for Method
	aClass compile: aMethodNode formattedCode

for Block
	Compiler evaluate: aSequenceNode formattedCode"
	
	"or formattedString"! !

!PPCoralParser methodsFor: 'productions' stamp: 'DamienPollet 8/11/2011 22:05'!
block
	^ super block ==> [ :nodes |
		"waiting for the new compiler. For the moment we ask the old compiler to recompile everything"
		Compiler evaluate: nodes body formattedCode	
		]
	
! !

!PPCoralParser methodsFor: 'productions' stamp: 'sd 11/8/2010 10:21'!
method

	^ super method ==> [ :nodes |
			"waiting for the new compiler. For the moment we ask the old compiler to recompile everything"
					nodes first key compile:
						(nodes first value
								pragmas: nodes second second , nodes second fourth;
								body: (self smalltalk 
												build: nodes second third
												sequence: nodes second fifth);
										yourself) formattedCode ]! !

!PPCoralParser methodsFor: 'productions' stamp: 'TestRunner 12/9/2009 21:32'!
methodHeader
	^ super methodHeader map: [ :className :metaclass :separator :methodDecl |
		| class |
		class := Smalltalk classNamed: className value.
		metaclass isNil ifFalse: [ class := class class ].
		class -> methodDecl ]! !

!PPCoralParser methodsFor: 'productions' stamp: 'TestRunner 12/7/2009 16:20'!
program
	^ super program ==> #second! !

!PPCoralParser methodsFor: 'composition' stamp: 'lr 12/7/2009 13:52'!
smalltalk
	^ smalltalk ifNil: [ smalltalk := PPSmalltalkParser new ]! !

!OS2Process methodsFor: '*Coral-Core' stamp: 'DamienPollet 8/13/2011 03:14'!
newLineInConsole
	
	^String cr, String lf! !

!MacProcess methodsFor: '*Coral-Core' stamp: 'DamienPollet 8/13/2011 03:13'!
newLineInConsole
	
	self isUnix 
			ifTrue:[^String lf] 
			ifFalse:[^String cr]! !

Object subclass: #Console
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Core'!

Console class
	instanceVariableNames: 'prompt history'!

!Console commentStamp: 'DamienPollet 7/28/2011 16:03' prior: 0!
Console provides convenient access to standard input/output streams plus methods to help display text on a unix terminal (using ANSI control sequences).

!

Console class
	instanceVariableNames: 'prompt history'!

!Console class methodsFor: 'output' stamp: 'DamienPollet 1/30/2012 15:33'!
<< anObject

	self print: anObject! !

!Console class methodsFor: 'private' stamp: 'OlivierAuverlot 12/7/2010 21:27'!
addToHistory: aString
	"add command line to history"

	history add: aString.! !

!Console class methodsFor: 'private' stamp: 'OlivierAuverlot 12/4/2010 21:33'!
banner
	"Display the Coral banner"

	Console printNl: '                                            \   /'.
	Console printNl: '------------------------------------------    *'.
	Console printNl: 'Pharo                                       /|=|\'.	
	Console printNl: 'open-source Smalltalk-inspired environment   |=|'.	
	Console printNl: '------------------------------------------  |===|'.! !

!Console class methodsFor: 'console' stamp: 'OlivierAuverlot 12/24/2010 15:03'!
clear
	"clear the history"
	history removeAll
! !

!Console class methodsFor: 'output' stamp: 'DamienPollet 8/11/2011 21:48'!
cr 
	
	self << String cr! !

!Console class methodsFor: 'output' stamp: 'OlivierAuverlot 11/19/2010 19:28'!
displayAttributes: attributes
	"Sets multiple display attribute settings
	
	0	Reset all attributes
	1	Bright
	2	Dim
	4	Underscore	
	5	Blink
	7	Reverse
	8	Hidden

	Foreground Colours
	30	Black
	31	Red
	32	Green
	33	Yellow
	34	Blue
	35	Magenta
	36	Cyan
	37	White

	Background Colours
	40	Black
	41	Red
	42	Green
	43	Yellow
	44	Blue
	45	Magenta
	46	Cyan
	47	White

<ESC>[{attr1};...;{attrn}m
	
	Console displayAttribute: #(1 33 40)"


	| stream cmd |
	
	cmd := WriteStream on: String new.
	stream := attributes readStream.
	
	stream do: [ 
		:att | 
		cmd nextPutAll: att asString.
		(stream atEnd not) ifTrue: [ cmd nextPutAll: ';' ]
	].

	Console esc: '[' , (cmd contents) , 'm'.! !

!Console class methodsFor: 'output' stamp: 'DamienPollet 1/30/2012 15:33'!
eraseScreen
	"Erases the screen with the background colour and moves the cursor to home."

	self esc: '[2J'.
	! !

!Console class methodsFor: 'output' stamp: 'DamienPollet 1/30/2012 15:33'!
esc: escapeSequence
	"Output escape sequence to console"

	self print: #[27] , escapeSequence.
		! !

!Console class methodsFor: 'console' stamp: 'DamienPollet 8/11/2011 21:56'!
go: lineNumber
	"execute the specified line in history"
	
	history removeLast.
	
	(lineNumber > 0 & lineNumber <= history size) ifTrue: [
		[ PPCoralParser parse: '[' , (history at: lineNumber) , ']' ]
			on: Exception
			do: [ :ex | Console printNl: ex printString ]
	]
		
		! !

!Console class methodsFor: 'private' stamp: 'OlivierAuverlot 12/7/2010 21:24'!
initHistory
	"initialize the console history"

	history := OrderedCollection new.! !

!Console class methodsFor: 'output' stamp: 'DamienPollet 8/11/2011 21:48'!
lf 
	
	self << String lf! !

!Console class methodsFor: 'private' stamp: 'OlivierAuverlot 12/7/2010 21:48'!
listHistory
	"display the content of the console history"

	history doWithIndex: [ :each :i | Console printNl: (i asString , ' -> ' , each) ].! !

!Console class methodsFor: 'output' stamp: 'DamienPollet 1/30/2012 15:33'!
locate: position
	"Sets the cursor position where subsequent text will begin"
	
	self esc: '[' , (position y) asString , ';' , (position x) asString , 'f'.
	! !

!Console class methodsFor: 'output' stamp: 'DamienPollet 1/30/2012 15:44'!
newline
	
	self << self newlineString! !

!Console class methodsFor: 'output' stamp: 'DamienPollet 1/30/2012 15:43'!
newlineString
	
	^ OSProcess thisOSProcess newLineInConsole! !

!Console class methodsFor: 'output' stamp: 'ms 10/1/2006 18:50'!
nextPutAll: aStream

	OSProcess thisOSProcess stdOut nextPutAll: aStream! !

!Console class methodsFor: 'output' stamp: 'DamienPollet 1/30/2012 15:33'!
plot: position
	"comment stating purpose of message"

	self locate: position; print: ' '.! !

!Console class methodsFor: 'output' stamp: 'DamienPollet 1/30/2012 15:31'!
print: anObject

	(OSProcess thisOSProcess stdOut
			converter: (TextConverter newForEncoding: 'UTF-8'))
		nextPutAll: anObject asString! !

!Console class methodsFor: 'output' stamp: 'DamienPollet 1/30/2012 15:32'!
printError: anObject

	(OSProcess thisOSProcess stdErr
			converter: (TextConverter newForEncoding: 'UTF-8'))
		nextPutAll: anObject asString! !

!Console class methodsFor: 'output' stamp: 'DamienPollet 1/30/2012 15:41'!
printNl: anObject

	self
		print: anObject;
		print: self newlineString
	! !

!Console class methodsFor: 'output' stamp: 'DamienPollet 1/30/2012 15:41'!
printNlError: anObject

	self
		printError: anObject;
		printError: self newlineString
	! !

!Console class methodsFor: 'output' stamp: 'DamienPollet 1/30/2012 15:38'!
printTab
	"display a tab"

	self print: Character tab! !

!Console class methodsFor: 'output' stamp: 'OlivierAuverlot 12/4/2010 21:23'!
prompt
	"return the prompt"

	^prompt! !

!Console class methodsFor: 'output' stamp: 'OlivierAuverlot 12/4/2010 21:24'!
prompt: aString
	"set the prompt"

	prompt := aString.	! !

!Console class methodsFor: 'output' stamp: 'DamienPollet 1/30/2012 15:42'!
puts: aString
	self printNl: aString! !

!Console class methodsFor: 'input' stamp: 'OlivierAuverlot 12/4/2010 22:04'!
read
	"Read a string until newline"
	| inputStr exitShell |
	
	exitShell := false.
		
	Console print: Console prompt.
		
	[ exitShell ] whileFalse: [	
				((inputStr := OSProcess readFromStdIn) = '') ifFalse: [
						inputStr := inputStr allButLast.
						exitShell := true. ]].
				
	^inputStr
	
! !

!Console class methodsFor: 'input' stamp: 'DamienPollet 8/15/2011 12:35'!
readOneCharacter
	^ OSProcess thisOSProcess stdIn next! !

!Console class methodsFor: 'output' stamp: 'OlivierAuverlot 11/19/2010 19:28'!
resetAllAttributes
	"Reset all display attributes"
	
	Console displayAttributes: #(0).
! !

Object subclass: #CoralScriptLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Core'!

!CoralScriptLoader commentStamp: 'StephaneDucasse 1/3/2010 17:44' prior: 0!
CoralScriptLoader is responsible to load and debug scripts.
For now you can either launch the vm in 
	- headless mode and you should not use the other coral options. 
	
	#!! /bin/sh
	vm='/Applications/Squeak/Squeak 4.2.2beta1U.app/Contents/MacOS/Squeak VM Opt'
	"$vm" -headless "coral.image" "`pwd`/$1"
	
	You can use ./coral.sh yourscript.psc  (pharoScript) or .cor for coral.
	
	- debug mode
	
	#!! /bin/sh
	vm='/Applications/Squeak/Squeak 4.2.2beta1U.app/Contents/MacOS/Squeak VM Opt'
	"$vm" "coral.image" "`pwd`/$1" -noquit
	
	In debugmode you can specify that the vm does not quit after execution using -noquit and that the execution
	of the script is halted before its execution using -haltAtStart
	 
	-haltAtStart means that a break point should be on before executing the script (in such case -headless should not be on)!

!CoralScriptLoader class methodsFor: 'initialize-release' stamp: 'AdrienBarreau 5/10/2011 21:41'!
initialize
	"self initialize"	
	
	Smalltalk addToStartUpList: self.
	Smalltalk at: #AbstractLauncher ifPresent: [ :arg | (Smalltalk at: #AbstractLauncher) deactivate ].
	Smalltalk at: #CommandLine ifPresent: [ :arg | CodeLoader enableCommandLineHandling: false ]! !

!CoralScriptLoader class methodsFor: 'initialize-release' stamp: 'DamienPollet 1/30/2012 15:57'!
runConsole
	| exitShell inputStr |
	Console banner.
	exitShell := false.
		
	[ exitShell ] whileFalse: [
		((inputStr := Console read) = '') 
			ifTrue: [ Console listHistory ]
			ifFalse: [
				Console addToHistory: inputStr.
				[ Console puts: (PPCoralParser parse: '[' , inputStr , ']') first printString ]
					on: Exception
					do: [ :ex | Console print: 'CoralScriptLoader handler: '. Console printNlError: ex printString ] ]
			]! !

!CoralScriptLoader class methodsFor: 'initialize-release' stamp: 'DamienPollet 1/30/2012 16:02'!
runScript

	| script stream |
	script := ((SmalltalkImage current documentPath) ifNil:['']) convertFromSystemString.
	script isEmpty ifTrue: [^ self ].
	
	stream := FileStream readOnlyFileNamed: script.
	stream converter: (TextConverter newForEncoding: 'UTF-8').
	
	CoralScriptWriting resetArguments.
	[PPCoralParser parse: stream contents]
		on: Exception do: [ :ex |
			(ex isKindOf: InMidstOfFileinNotification) 
				ifTrue:[ ex resume: false ]
				ifFalse: [
					Console printNlError: ex printString.
					(CommandLine uniqueInstance hasOption: #debug)
						ifTrue: [ Console printError: 'Spawning a debugger...'. ex pass ]
						ifFalse: [ Smalltalk logError: ex printString inContext: thisContext ] ] ].

	(CommandLine uniqueInstance hasOption: #debug)
		ifFalse: [Smalltalk quitPrimitive]
! !

!CoralScriptLoader class methodsFor: 'initialize-release' stamp: 'DamienCassou 8/24/2011 12:20'!
startUp
	"Smalltalk addToStartUpList: self"
	
	Smalltalk addDeferredStartupAction: [
		Console initHistory.
		Console prompt: '> '.
		
		((SmalltalkImage current documentPath) = '') 
			ifTrue: [ self runConsole ]
			ifFalse: [ self runScript ] ]! !

Object subclass: #CoralScriptWriting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Core'!

CoralScriptWriting class
	instanceVariableNames: 'currentArgs coralArgsCollection'!

!CoralScriptWriting commentStamp: 'DamienPollet 7/28/2011 16:10' prior: 0!
A CoralScriptWriting represents the execution environment of a Coral script, from the script writer's point of view.
!

CoralScriptWriting class
	instanceVariableNames: 'currentArgs coralArgsCollection'!

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 5/16/2011 16:13'!
getAllArguments
	currentArgs ifNil: [ 
		| coralArgs flag |
		flag := true.
		coralArgs := SmalltalkImage current extractMinusParameters.
		
		coralArgs isNil ifTrue: [ flag := false ] ifFalse: [ flag := coralArgs includesKey: #coralArgs ].
		
		flag 
			ifTrue: [ 
				coralArgs := coralArgs at: #coralArgs.
				coralArgsCollection := (coralArgs first subStrings: '"') reject: [ :each | each = String space ].
				currentArgs := SmalltalkImage current extractMinusParametersFrom: coralArgsCollection.
			]
			ifFalse: [ currentArgs := Dictionary new ]	
	].

	^ currentArgs deepCopy
	! !

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 10/8/2010 17:47'!
getAllArgumentsWithoutMinus
	^ self getAllArguments at: #*! !

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 10/8/2010 17:47'!
getAllArgumentsWithoutMinusButScriptName
	^ self getAllArgumentsWithoutMinus allButFirst! !

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 5/16/2011 16:14'!
getArgumentAt: aPosition
	^ coralArgsCollection at: aPosition
	! !

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 5/16/2011 16:14'!
getArgumentsNumber
	^ coralArgsCollection size
	! !

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 10/8/2010 17:47'!
getScriptName
	^ self getAllArgumentsWithoutMinus first! !

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 5/16/2011 17:29'!
hasOption: aString
	^ self getAllArguments keys includes: aString! !

!CoralScriptWriting class methodsFor: 'arguments' stamp: 'AdrienBarreau 10/8/2010 17:36'!
resetArguments 
	currentArgs := nil! !

!SmalltalkImage methodsFor: '*Coral-Core' stamp: 'DamienPollet 8/13/2011 03:15'!
associationForKey: aKey
	"Returns the association of a key and its value when passed to the vm"
	
	^ self extractParameters associationAt: aKey! !

!SmalltalkImage methodsFor: '*Coral-Core' stamp: 'DamienPollet 8/13/2011 03:16'!
extractMinusParameters
	"Returns a dictionary matching parameters beginning by a minus character and the list of the next parameters.
	Here is an example: 
		I suppose I run pharo with: `pharo myImage.image 1 2 3 woah -minus1 'Hello' -minus2 -minus3 'Hello' 'World'`.
		This message will return a dictionary with: 
			* --> #(1 2 3 'woah')
			minus1 --> #('Hello')
			minus2 --> #()
			minus3 --> #('Hello' 'World')"
			
	| args str index |
	
	args := OrderedCollection new.

	str := self getSystemAttribute: (index := 2).
	[ str isNil ] whileFalse: [ args add: str. str := self getSystemAttribute: (index := index + 1) ].

	^ self extractMinusParametersFrom: args! !

!SmalltalkImage methodsFor: '*Coral-Core' stamp: 'DamienPollet 8/13/2011 03:16'!
extractMinusParametersFrom: arguments
	| dict previous previousWithMinus args |
	
	dict := Dictionary new.
	
	arguments isEmptyOrNil ifTrue: [ ^ dict ].
	
	args := OrderedCollection withAll: arguments.

	previous := previousWithMinus := args detect: [ :each | each first = $- ] ifNone: [ String space ].
	[ args isEmpty or: [ args first = previous ] ] whileFalse: [ dict at: #* put: (dict at: #* ifAbsent: [ #() ]), (Array with: args first). args removeFirst ].
	
	args do: [ :each |
		(each first = $-)
			ifTrue: [ 
				(previous first = $-) ifTrue: [ dict at: previous allButFirst put: #() ].
				previousWithMinus := each ]
			ifFalse: [ dict at: previousWithMinus allButFirst put: ((dict at: previousWithMinus allButFirst ifAbsent: [ #() ]), (Array with: each)) ].
				
		previous := each.
	].

	(previous first = $-) ifTrue: [ dict at: previous allButFirst put: #() ].

	^ dict! !

!SmalltalkImage methodsFor: '*Coral-Core' stamp: 'DamienPollet 8/13/2011 03:16'!
hasKey: aKey
	"Returns true if the key was passed in argument when launching the vm."
	
	self extractParameters 
		at: aKey ifAbsent: [^ false].
	^ true.! !

!SmalltalkImage methodsFor: '*Coral-Core' stamp: 'DamienPollet 8/13/2011 03:16'!
shouldHaltAtStart
	"Coral specific: 
	In coral you can launch the vm that way
	
	 /Applications/Squeak/Squeak\ 4.2.2beta1U.app/Contents/MacOS/Squeak\ VM\ Opt  
		coral.image 
		Hello.st -noquit
	
	-noquit means that the vm should not quit after execution (in such case -headless should not be on)
		 /Applications/Squeak/Squeak\ 4.2.2beta1U.app/Contents/MacOS/Squeak\ VM\ Opt 
				 -headless coral.image Hello.st 
	
	-haltAtStart means that a break point should be on before executing the script (in such case -headless 		should not be on)
	"
	^ (self hasKey: '-HALTATSTART')! !

!SmalltalkImage methodsFor: '*Coral-Core' stamp: 'DamienPollet 8/13/2011 03:16'!
shouldQuitAfterExecution
	"Coral specific: 
	In coral you can launch the vm that way
	
	 /Applications/Squeak/Squeak\ 4.2.2beta1U.app/Contents/MacOS/Squeak\ VM\ Opt  
		coral.image 
		Hello.st -noquit
	
	-noquit means that the vm should not quit after execution (in such case -headless should not be on)
		 /Applications/Squeak/Squeak\ 4.2.2beta1U.app/Contents/MacOS/Squeak\ VM\ Opt 
				 -headless coral.image Hello.st 
	
	-haltAtStart means that a break point should be on before executing the script (in such case -headless 		should not be on)
	"
	^ (self hasKey: '-NOQUIT') not! !
CoralScriptLoader initialize!
